<script setup>
import { computed, onMounted, reactive, ref } from "vue";
import { useStore } from "vuex";
import { useRouter, useRoute } from "vue-router";
import { mdiEye, mdiTrashCan, mdiPencilOutline } from "@mdi/js";
import ModalBox from "@/components/ModalBox.vue";
import CheckboxCell from "@/components/CheckboxCell.vue";
import Level from "@/components/Level.vue";
import JbButtons from "@/components/JbButtons.vue";
import JbButton from "@/components/JbButton.vue";
import UserAvatar from "@/components/UserAvatar.vue";
import CheckRadioPicker from "@/components/CheckRadioPicker.vue";
import ToggleButton from "@/components/ToggleButton.vue";
import { useToast } from "vue-toastification";
import SearchBox from "@/components/SearchBox.vue";
import Institute from "@/api/institute";
import Toggle from "@vueform/toggle";
defineProps({
  checkable: Boolean,
});
const router = useRouter();
const route = useRoute();
const store = useStore();
const toast = useToast();
const lightBorderStyle = computed(() => store.state.lightBorderStyle);
const lightBgStyle = computed(() => store.state.lightBgStyle);
const tableTrStyle = computed(() => store.state.tableTrStyle);
const tableTrOddStyle = computed(() => store.state.tableTrOddStyle);
const darkMode = computed(() => store.state.darkMode);
const searchText = ref("");
const HospitalID = ref("");
var hospitalList = reactive({ value: [] });
var paginationList = reactive({ value: {} });
const getId = ref("");
const order = ref(-1);
const field = ref("name");
const currentPage = ref(1);

onMounted(() => {
  loadPage({
    page: currentPage.value,
    orderBy: field.value,
    orderIn: order.value,
  });
});

const hospitalitems = computed(() => {
  return hospitalList.value;
});

const insititutess = reactive({ insititutes: "" });
// Delete Table
const delHospital = (insititutes) => {
  insititutess.insititutes = insititutes;
  console.log("line55", insititutes);
  isModalDangerActive.value = true;
};
// Delete Institute
const del = (instituteId) => {
  Institute.delete(instituteId).then((data) => {
    console.log("line61", instituteId);
    console.log("deletedata", data?.success);
    if (data?.success) {
      toast.success(data?.message);
      isModalDangerActive.value = false;
      loadPage({
        page: currentPage.value,
        orderBy: field.value,
      });
    } else {
      toast.error(data?.message);
    }
  });
};
// Institute Status
const instituteStatus = (instituteId, index) => {
  Institute.toggleStatus(instituteId).then((data) => {
    if (data?.success) {
      toast.success(data?.message);
      loadPage({
        page: currentPage.value,
        orderBy: field.value,
      });
    } else {
      toast.error(data?.message);
    }
  });
};
const isModalActive = ref(false);
const isModalDangerActive = ref(false);
const checkedRows = ref([]);

const checked = (isChecked, insititutes) => {
  if (isChecked) {
    checkedRows.value.push(insititutes);
  } else {
    checkedRows.value = remove(
      checkedRows.value,
      (row) => row.id === insititutes.instituteId
    );
  }
};
// View Single Hospital Details
const setCurrentHospital = (insititutes) => {
  store.commit("setCurrentHospital", { insititutes: insititutes });
};
//
const setTitle = (title) => {
  store.commit("setTitle", { title: title });
  store.commit("setRouterTitle", { routerTitle: "" });
};
const loadPage = ({ page, orderBy, orderIn }) => {
  if (orderIn) {
    console.log("orderIn");
    if (order.value == 1) {
      order.value = -1;
    } else {
      order.value = 1;
    }
  }
  if (page) {
    currentPage.value = page;
  }
  if (orderBy) {
    field.value = orderBy;
  }
  console.log("pagenumber", page);
  Institute.getAll({
    searchText: searchText.value,
    page: currentPage.value,
    orderBy,
    orderIn: order.value,
  }).then((data) => {
    hospitalList.value = data?.data?.insititutes;
    console.log("hospitalList", hospitalList);
    paginationList.value = data?.data?.pagination;
    console.log("paginationList", paginationList.value);
  });
};
</script>

<template>
  <div class="flex justify-between w-full md:px-4 px-2 my-6 bg-none">
    <div
      class="relative text-gray-600 focus-within:text-gray-400 md:w-80 w-50 h-8"
    >
      <span class="absolute flex items-center pl-2 py-2">
        <button
          type="submit"
          class="p-1 focus:outline-none focus:shadow-outline"
        >
          <svg
            fill="none"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            viewBox="0 0 24 24"
            class="w-4 h-4"
          >
            <path d="M21 21l-6-6m2-5a7 7 0 11-14 0 7 7 0 0114 0z"></path>
          </svg>
        </button>
      </span>
      <input
        v-model="searchText"
        @input="loadPage({})"
        type="search"
        class="h-10 py-2.5 hover:border active:border active:text-pink-250 shadow-sm w-full text-sm text-white border-0 border-gray-150 bg-white rounded-full pl-10 focus:outline-none focus:border-pink-40 focus:ring-1 focus:ring-pink-250 focus:bg-white focus:text-gray-900"
        placeholder="Search..."
        autocomplete="off"
      />
    </div>
    <jb-button
      class="btnColor hover:bg-pink-250 px-4 py-2"
      label="Add Hospital"
      to="/add-hospital"
      :small="buttonsSmall"
      :outline="buttonsOutline"
      :disabled="buttonsDisabled"
    />
  </div>
  <div
    v-if="checkedRows.length"
    class="bg-opacity-50 p-3 dark:bg-gray-800"
    :class="lightBgStyle"
  >
    <span
      v-for="checkedRow in checkedRows"
      :key="checkedRow.id"
      class="inline-block px-2 py-1 mt-4 rounded-sm mr-2 text-sm dark:bg-gray-700"
      :class="lightBgStyle"
    >
      {{ checkedRow.name }}
    </span>
  </div>
  <table class="rounded-t-lg bg-white mt-6">
    <thead class="bg-pink-150 text-sm text-center rounded-t-lg">
      <tr class="text-black-150 font-bold rounded-t-lg">
        <td v-if="checkable" />
        <td class="px-2 py-4 text-left">Sr. No.</td>
        <td class="px-2 py-4 flex justify-around-between">
          <span class="text-left">Hospital Name</span>
          <span class=""
            ><img
              @click="loadPage({ orderBy: 'name', orderIn: 1 })"
              src="@/assets/icons/filter-icon.svg"
          /></span>
        </td>
        <td class="px-2 py-4 text-left">Contact No.</td>
        <td class="px-2 py-4 text-center">Total Staff</td>
        <td class="px-2 py-4 text-center">Total Patient</td>
        <td class="px-2 py-4 text-center">High Risk Patient</td>
        <td class="px-2 py-4 text-center">Status</td>
        <td class="px-2 py-4 text-center">Action</td>
      </tr>
    </thead>
    <tbody>
      <TransitionGroup>
        <tr
          v-for="(insititutes, index) in hospitalitems"
          :key="insititutes.instituteId"
          :class="text - center"
          class="text-center text-sm text-gray-250 font-medium border-b border-gray-150"
        >
          <checkbox-cell
            v-if="checkable"
            @checked="checked($event, insititutes)"
          />
          <td class="no text-left">
            {{ index + 1 }}
          </td>
          <td data-label="Name" class="text-left">
            <router-link
              :to="{
                name: 'StaffCard',
                params: { instituteId: insititutes.instituteId },
              }"
            >
              <span @click="setTitle(insititutes.name)">
                {{ insititutes.name }}</span
              >
            </router-link>
          </td>
          <td data-label="contact" class="text-left">
            {{ insititutes.mobile }}
          </td>
          <td data-label="staff" class="text-center">
            {{ insititutes.totalStaff }}
          </td>
          <td data-label="patient" class="text-center">
            {{ insititutes.totalPatient }}
          </td>

          <td data-label="risk_patient" class="text-center text-pink-250">
            {{ insititutes.risk_patient }}
          </td>
          <td data-label="Status" class="text-center">
            <field class="flex-wrap">
              <toggle-button
                @change="instituteStatus(insititutes.instituteId)"
                v-model="insititutes.isActive"
                :data="insititutes.isActive"
              />
              <Transition name="fade" mode="out-in">
                <p
                  v-if="insititutes.isActive == true"
                  data="true"
                  class="text-gray-400 font-medium"
                >
                  Active
                </p>
                <p v-else class="text-gray-400 font-medium">Inactive</p>
              </Transition>
            </field>
          </td>
          <td class="flex py-4">
            <router-link
              :to="{
                name: 'hospital-detail',
                params: { instituteId: insititutes.instituteId },
              }"
            >
              <img
                @click="setCurrentHospital(insititutes)"
                src="@/assets/icons/eyes.svg"
              />
            </router-link>
            <img
              class="cursor-pointer"
              @click="delHospital(insititutes)"
              src="@/assets/icons/delete.svg"
            />
          </td>
          <!-- Delete Confirmation Modal -->
          <Transition :duration="{ enter: 500, leave: 800 }" name="nested">
            <modal-box
              v-model="isModalDangerActive"
              title="&nbsp;"
              button="danger"
              has-cancel
            >
              <h1 class="my-2 text-lg">Please confirm</h1>
              <p class="my-2 text-base">
                Are you sure you want to delete this insititute?
              </p>
              <div class="py-6 text-sm">
                <jb-buttons class="flex justify-center">
                  <jb-button
                    color="light"
                    label="No"
                    @click="isModalDangerActive = false"
                    class="rounded-lg px-4 py-2 text-pink-250 border-pink-250 bg-pink-40 mr-4"
                    :small="buttonsSmall"
                    :outline="buttonsOutline"
                    :disabled="buttonsDisabled"
                  />

                  <jb-button
                    class="text-white bg-pink-250 hover:bg-pink-250 rounded-lg px-4 py-2 ml-4"
                    label="Yes"
                    @click="del((Hid = insititutess.insititutes.instituteId))"
                    :small="buttonsSmall"
                    :outline="buttonsOutline"
                    :disabled="buttonsDisabled"
                  />
                </jb-buttons>
              </div>
            </modal-box>
          </Transition>
          <!-- Delete Confirmation Modal -->
        </tr>
      </TransitionGroup>
    </tbody>
  </table>
  <div
    v-if="paginationList.value"
    :class="lightBorderStyle"
    class="px-3 py-6 lg:px-6 border-t dark:border-gray-800"
  >
    <level>
      <small
        >Page {{ paginationList.value?.currentPage }} of
        {{ paginationList.value?.totalPages }}</small
      >
      <jb-buttons>
        <jb-button
          v-for="(n, index) in paginationList.value?.totalPages"
          :key="index"
          :active="n === paginationList.value?.currentPage"
          :label="n"
          :outline="darkMode"
          class="focus:bg-pink-250 w-8 h-8 text-sm hover:bg-pink-250 focus:outline-none active:border-0 active:bg-pink-250 focus:border-0 focus:ring-1 active:ring-1 active:ring-pink-250 focus:ring-pink-250 focus:text-white"
          small
          @click="loadPage({ page: n })"
        />
      </jb-buttons>
    </level>
  </div>
</template>
